import 'symbol-observable';
import { Subscription as SubscriptionComponent } from 'create-subscription';
import * as React from 'react';
export { SubscriptionComponent };
export interface Observable<T> {
    subscribe(onNext: (val: T) => any, onError?: Function, onComplete?: Function): Subscription;
    [Symbol.observable](): this;
}
export interface Subscription {
    unsubscribe(): void;
}
export interface SubscribeProps<T> {
    children: SubscribeChildren<T>;
}
declare type SubscribeChildren<T> = {
    subscribe: Observable<T>['subscribe'];
} | {
    [Symbol.observable](): Observable<T>;
};
export declare class Subscribe<T = any> extends React.Component<SubscribeProps<T>> {
    private SubscriptionComponent;
    render(): JSX.Element;
    private getObservableFromChildren;
    private getSubscriptionComponent;
}
