(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
    (factory((global['react-with-observable'] = {}),global.React));
}(this, (function (exports,React) { 'use strict';

    var React__default = 'default' in React ? React['default'] : React;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function symbolObservablePonyfill(root) {
    	var result;
    	var Symbol = root.Symbol;

    	if (typeof Symbol === 'function') {
    		if (Symbol.observable) {
    			result = Symbol.observable;
    		} else {
    			result = Symbol('observable');
    			Symbol.observable = result;
    		}
    	} else {
    		result = '@@observable';
    	}

    	return result;
    }

    /* global window */

    var root;

    if (typeof self !== 'undefined') {
      root = self;
    } else if (typeof window !== 'undefined') {
      root = window;
    } else if (typeof global !== 'undefined') {
      root = global;
    } else if (typeof module !== 'undefined') {
      root = module;
    } else {
      root = Function('return this')();
    }

    var result = symbolObservablePonyfill(root);

    function unwrapExports (x) {
    	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
    }

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     *
     */

    /**
     * Use invariant() to assert state which your program assumes to be true.
     *
     * Provide sprintf-style format (only %s is supported) and arguments
     * to provide information about what broke and what you were
     * expecting.
     *
     * The invariant message will be stripped in production, but the invariant
     * will remain to ensure logic does not differ in production.
     */

    var validateFormat = function validateFormat(format) {};

    if (process.env.NODE_ENV !== 'production') {
      validateFormat = function validateFormat(format) {
        if (format === undefined) {
          throw new Error('invariant requires an error message argument');
        }
      };
    }

    function invariant(condition, format, a, b, c, d, e, f) {
      validateFormat(format);

      if (!condition) {
        var error;
        if (format === undefined) {
          error = new Error('Minified exception occurred; use the non-minified dev environment ' + 'for the full error message and additional helpful warnings.');
        } else {
          var args = [a, b, c, d, e, f];
          var argIndex = 0;
          error = new Error(format.replace(/%s/g, function () {
            return args[argIndex++];
          }));
          error.name = 'Invariant Violation';
        }

        error.framesToPop = 1; // we don't care about invariant's own frame
        throw error;
      }
    }

    var invariant_1 = invariant;

    var createSubscription_production_min = createCommonjsModule(function (module, exports) {
    Object.defineProperty(exports,"__esModule",{value:!0});function p(a){for(var b=arguments.length-1,e="https://reactjs.org/docs/error-decoder.html?invariant="+a,f=0;f<b;f++)e+="&args[]="+encodeURIComponent(arguments[f+1]);invariant_1(!1,"Minified React error #"+a+"; visit %s for the full message or use the non-minified dev environment for full errors and additional helpful warnings. ",e);}
    function q(a,b){if(!a)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return !b||"object"!==typeof b&&"function"!==typeof b?a:b}function r(a,b){if("function"!==typeof b&&null!==b)throw new TypeError("Super expression must either be null or a function, not "+typeof b);a.prototype=Object.create(b&&b.prototype,{constructor:{value:a,enumerable:!1,writable:!0,configurable:!0}});b&&(Object.setPrototypeOf?Object.setPrototypeOf(a,b):a.__proto__=b);}
    exports.createSubscription=function(a){var b=a.getCurrentValue,e=a.subscribe;return function(a){function c(){var h,d,k;if(!(this instanceof c))throw new TypeError("Cannot call a class as a function");for(var l=arguments.length,m=Array(l),e=0;e<l;e++)m[e]=arguments[e];return k=(h=(d=q(this,a.call.apply(a,[this].concat(m))),d),d.state={source:d.props.source,value:null!=d.props.source?b(d.props.source):void 0},d._hasUnmounted=!1,d._unsubscribe=null,h),q(d,k)}r(c,a);c.getDerivedStateFromProps=function(a,
    d){return a.source!==d.source?{source:a.source,value:null!=a.source?b(a.source):void 0}:null};c.prototype.componentDidMount=function(){this.subscribe();};c.prototype.componentDidUpdate=function(a,b){this.state.source!==b.source&&(this.unsubscribe(b),this.subscribe());};c.prototype.componentWillUnmount=function(){this.unsubscribe(this.state);this._hasUnmounted=!0;};c.prototype.render=function(){return this.props.children(this.state.value)};c.prototype.subscribe=function(){var a=this,d=this.state.source;
    if(null!=d){var c=e(d,function(b){a._hasUnmounted||a.setState(function(a){return b===a.value||d!==a.source?null:{value:b}});});"function"!==typeof c?p("266"):void 0;this._unsubscribe=c;c=b(this.props.source);c!==this.state.value&&this.setState({value:c});}};c.prototype.unsubscribe=function(){"function"===typeof this._unsubscribe&&this._unsubscribe();this._unsubscribe=null;};return c}(React__default.Component)};
    });

    unwrapExports(createSubscription_production_min);
    var createSubscription_production_min_1 = createSubscription_production_min.createSubscription;

    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     *
     * 
     */

    function makeEmptyFunction(arg) {
      return function () {
        return arg;
      };
    }

    /**
     * This function accepts and discards inputs; it has no side effects. This is
     * primarily useful idiomatically for overridable function endpoints which
     * always need to be callable, since JS lacks a null-call idiom ala Cocoa.
     */
    var emptyFunction = function emptyFunction() {};

    emptyFunction.thatReturns = makeEmptyFunction;
    emptyFunction.thatReturnsFalse = makeEmptyFunction(false);
    emptyFunction.thatReturnsTrue = makeEmptyFunction(true);
    emptyFunction.thatReturnsNull = makeEmptyFunction(null);
    emptyFunction.thatReturnsThis = function () {
      return this;
    };
    emptyFunction.thatReturnsArgument = function (arg) {
      return arg;
    };

    var emptyFunction_1 = emptyFunction;

    /**
     * Similar to invariant but only logs a warning if the condition is not met.
     * This can be used to log issues in development environments in critical
     * paths. Removing the logging code for production environments will keep the
     * same logic and follow the same code paths.
     */

    var warning = emptyFunction_1;

    if (process.env.NODE_ENV !== 'production') {
      var printWarning = function printWarning(format) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        var argIndex = 0;
        var message = 'Warning: ' + format.replace(/%s/g, function () {
          return args[argIndex++];
        });
        if (typeof console !== 'undefined') {
          console.error(message);
        }
        try {
          // --- Welcome to debugging React ---
          // This error was thrown as a convenience so that you can use this stack
          // to find the callsite that caused this warning to fire.
          throw new Error(message);
        } catch (x) {}
      };

      warning = function warning(condition, format) {
        if (format === undefined) {
          throw new Error('`warning(condition, format, ...args)` requires a warning ' + 'message argument');
        }

        if (format.indexOf('Failed Composite propType: ') === 0) {
          return; // Ignore CompositeComponent proptype check.
        }

        if (!condition) {
          for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
            args[_key2 - 2] = arguments[_key2];
          }

          printWarning.apply(undefined, [format].concat(args));
        }
      };
    }

    var warning_1 = warning;

    var createSubscription_development = createCommonjsModule(function (module, exports) {



    if (process.env.NODE_ENV !== "production") {
      (function() {

    Object.defineProperty(exports, '__esModule', { value: true });

    var invariant = invariant_1;
    var React$$1 = React__default;
    var warning = warning_1;

    // Relying on the `invariant()` implementation lets us
    // have preserve the format and params in the www builds.

    function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

    function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

    function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

    function createSubscription(config) {
      var getCurrentValue = config.getCurrentValue,
          _subscribe = config.subscribe;


      !(typeof getCurrentValue === 'function') ? warning(false, 'Subscription must specify a getCurrentValue function') : void 0;
      !(typeof _subscribe === 'function') ? warning(false, 'Subscription must specify a subscribe function') : void 0;

      // Reference: https://gist.github.com/bvaughn/d569177d70b50b58bff69c3c4a5353f3
      var Subscription = function (_React$Component) {
        _inherits(Subscription, _React$Component);

        function Subscription() {
          var _temp, _this, _ret;

          _classCallCheck(this, Subscription);

          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
            source: _this.props.source,
            value: _this.props.source != null ? getCurrentValue(_this.props.source) : undefined
          }, _this._hasUnmounted = false, _this._unsubscribe = null, _temp), _possibleConstructorReturn(_this, _ret);
        }

        Subscription.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
          if (nextProps.source !== prevState.source) {
            return {
              source: nextProps.source,
              value: nextProps.source != null ? getCurrentValue(nextProps.source) : undefined
            };
          }

          return null;
        };

        Subscription.prototype.componentDidMount = function componentDidMount() {
          this.subscribe();
        };

        Subscription.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
          if (this.state.source !== prevState.source) {
            this.unsubscribe(prevState);
            this.subscribe();
          }
        };

        Subscription.prototype.componentWillUnmount = function componentWillUnmount() {
          this.unsubscribe(this.state);

          // Track mounted to avoid calling setState after unmounting
          // For source like Promises that can't be unsubscribed from.
          this._hasUnmounted = true;
        };

        Subscription.prototype.render = function render() {
          return this.props.children(this.state.value);
        };

        Subscription.prototype.subscribe = function subscribe() {
          var _this2 = this;

          var source = this.state.source;

          if (source != null) {
            var _callback = function (value) {
              if (_this2._hasUnmounted) {
                return;
              }

              _this2.setState(function (state) {
                // If the value is the same, skip the unnecessary state update.
                if (value === state.value) {
                  return null;
                }

                // If this event belongs to an old or uncommitted data source, ignore it.
                if (source !== state.source) {
                  return null;
                }

                return { value: value };
              });
            };

            // Store the unsubscribe method for later (in case the subscribable prop changes).
            var unsubscribe = _subscribe(source, _callback);
            !(typeof unsubscribe === 'function') ? invariant(false, 'A subscription must return an unsubscribe function.') : void 0;

            // It's safe to store unsubscribe on the instance because
            // We only read or write that property during the "commit" phase.
            this._unsubscribe = unsubscribe;

            // External values could change between render and mount,
            // In some cases it may be important to handle this case.
            var _value = getCurrentValue(this.props.source);
            if (_value !== this.state.value) {
              this.setState({ value: _value });
            }
          }
        };

        Subscription.prototype.unsubscribe = function unsubscribe(state) {
          if (typeof this._unsubscribe === 'function') {
            this._unsubscribe();
          }
          this._unsubscribe = null;
        };

        return Subscription;
      }(React$$1.Component);

      return Subscription;
    }

    exports.createSubscription = createSubscription;
      })();
    }
    });

    unwrapExports(createSubscription_development);
    var createSubscription_development_1 = createSubscription_development.createSubscription;

    var createSubscription = createCommonjsModule(function (module) {

    if (process.env.NODE_ENV === 'production') {
      module.exports = createSubscription_production_min;
    } else {
      module.exports = createSubscription_development;
    }
    });

    // rollup quirk
    var createSubscription$1 = undefined;
    var Subscribe = /** @class */ (function (_super) {
        __extends(Subscribe, _super);
        function Subscribe() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.SubscriptionComponent = _this.getSubscriptionComponent();
            return _this;
        }
        Subscribe.prototype.render = function () {
            var observable = this.getObservableFromChildren();
            return (React.createElement(this.SubscriptionComponent, { source: observable }, function (val) {
                if (typeof val === 'undefined') {
                    return '';
                }
                return val;
            }));
        };
        Subscribe.prototype.getObservableFromChildren = function () {
            var child = this.props.children;
            var observable = typeof child[Symbol.observable] === 'function' ? child[Symbol.observable]() : undefined;
            if (!observable) {
                throw new Error("<Subscribe>: Expected children to be a single Observable instance with a [Symbol.observable] method. See more: https://github.com/tc39/proposal-observable");
            }
            return observable;
        };
        Subscribe.prototype.getSubscriptionComponent = function () {
            var SubscriptionComponent = createSubscription$1({
                getCurrentValue: function (_observable) {
                    return undefined;
                },
                subscribe: function (observable, callback) {
                    var subscription = observable.subscribe(callback);
                    return function () { return subscription.unsubscribe(); };
                },
            });
            return SubscriptionComponent;
        };
        return Subscribe;
    }(React.Component));

    exports.Subscribe = Subscribe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
